'SuperStrict
'Import brl.stream
'Import brl.retro


Rem

unused characters:

]"
qk
EGJKMQTYZ

all available characters:

1234567890
!@#$%^&*()
abcdefghijklmnopqrstuvwxyz
ABCDEFGHIJKLMNOPQRSTUVWXYZ
[]{}
;:'"
,<.>/?
+-_=
\|

EndRem



Global lname$[1]
Global lpos%[1]
Global labels%=0

Global onstring%=0

Global comment%=0,lin$

Function Parse(fil:TStream)
	dopass 0
	dopass 1
	'checklabs
End Function




Rem
Function checklabs() 'check for duplicate labels.
	If labels>0
		For Local x%=0 To labels-1
			For Local o%=0 To labels-1
				If o<>x And lname[o]=lname[x] Print "ERROR: Duplicate label name "+lname[o];Exit
			Next
		Next
	EndIf
End Function
EndRem


Function DoPass(pass%,debug%=0)
	SeekStream fil,0
	inmem=0
	comment=0
	
	Repeat
		Local pmem%=inmem
		Repeat
			lin$=Trim(Replace(ReadLine(fil),Chr(9)," "))
		Until Len(Trim(lin))>0 Or Eof(fil)
		If debug Print "Parsing "+lin+" (pass "+pass+")"
		If Left(lin,1)="$"
			lin=Trim(Right(lin,Len(lin)-1))
			If Instr("0123456789",Left(lin,1)) Then
				inmem=Int(lin)
				If debug Print "Memory address reassigned to "+inmem
			ElseIf Left(lin,1)<>"~q"
				Local ll$=lin
				Local get$=""
				For Local c%=1 To Len(ll)
					If Mid(ll,c,2)="//" And c<Len(ll) Then Exit
					get:+Mid(ll,c,1)
				Next
				If Instr(get,"=") And Instr(get,":") Print "ERROR: ~q=~q and ~q:~q both found within the same label definition."
				If Instr(get,"=")
					Local assign$="",get2$="",mode%=0
					For Local in%=1 To Len(get)
						Local ch$=Mid(get,in,1)
						If ch="=" And mode=0
							mode=1
						Else
							If mode=0 get2:+ch Else assign:+ch
						EndIf
					Next
					get=Trim(get2)
					If mode=1
						assign=Trim(assign)
						If Left(assign,1)="["
							assign=Upto(assign,2,"]")
						Else
							assign=Asc(Left(assign,1))
						EndIf
						mem[inmem]=Int(assign)
					EndIf
					If pass=0 addlab get,inmem,debug
					inmem:+1
				ElseIf Instr(get,":")
					Local assign$="",get2$="",mode%=0
					For Local in%=1 To Len(get)
						Local ch$=Mid(get,in,1)
						If ch=":" And mode=0
							mode=1
						Else
							If mode=0 get2:+ch Else assign:+ch
						EndIf
					Next
					get=Trim(get2)
					If mode=1
						If pass=0
							assign=Trim(assign)
							If Left(assign,1)="["
								assign=Upto(assign,2,"]")
							Else
								assign=Asc(Left(assign,1))
							EndIf
							addlab get,Int(assign),debug
						EndIf
					EndIf
					inmem:+1
				Else
					If pass=0 addlab get,inmem,debug
				EndIf
			ElseIf Left(lin,1)="~q"
				If pass=0
					Local ll$=Trim(Right(lin,Len(lin)-1))
					Local get$=""
					For Local c%=1 To Len(ll)
						If Mid(ll,c,2)="//" And c<Len(ll) Then Exit
						get:+Mid(ll,c,1)
					Next
					If onstring
						othstring=get
						If debug Print "Secondary memory string set to "+get
					Else
						memstring=get
						If debug Print "Primary memory string set to "+get
					EndIf
					onstring=Not onstring
				EndIf
			EndIf
		Else
			Local wspace%=(Right(Trim(lin),1)="$")
			If wspace lin=Trim(Left(lin,Len(lin)-1))
			If debug And wspace Print "Whitespace line detected"
			Local p%=0
			Repeat
				p:+1
				Local c$=Mid(lin,p,1)
				If p<Len(lin) And Mid(lin,p,2)="//" Then
					comment=Not comment
					p:+1
				ElseIf comment=0
					If c="[" 'byte
						Local val$=upto(lin,p+1,"]")
						If pass=1 
							If Trim(val)="$$"
								mem[inmem]=inmem
							ElseIf Trim(val)="$" Or Trim(val)="|" Or Trim(val)="["
								mem[inmem]=Asc(Trim(val))
							Else
								mem[inmem]=Int(val)
							EndIf
						EndIf
						inmem:+1
						p:+Len(val)+1
					ElseIf c="|" 'label
						Local val$=Lower(Trim(upto(lin,p+1,"|")))
						If Left(Trim(val),1)="$"
							addlab Trim(Right(val,Len(val)-1)),inmem,debug
						Else
							If pass=1
								Local num%=0,found%=0
								For Local find%=0 To labels-1
									If lname[find]=val num=lpos[find];found=1;Exit
								Next
								mem[inmem]=num
								If Not found Print "ERROR: Undefined label "+val+" referenced. Substituting 0 instead."
							EndIf
							inmem:+1
						EndIf
						p:+Len(val)+1
					ElseIf (c<>" " And c<>Chr(9)) Or wspace=1
						If pass=1 mem[inmem]=Asc(c)
						inmem:+1
					EndIf
				EndIf
			Until p=>Len(lin)
			If debug Print "Processed line to memory (pass "+pass+")"
		EndIf
		If pass=0 And inmem>size-1 
			Print "Code exceeds maximum memory space of "+size+" values."
			Local pr$=""
			For Local go%=inmem-7 To inmem
				If go=>0 pr:+Chr(mem[go])
			Next
			Print "Last 8 bytes: "+pr
			Print "Previous position in memory: "+pmem
			inmem=inmem Mod size
		EndIf
	Until Eof(fil)
	
	If comment And pass=0 Print "ERROR: File contains unclosed comment"
	
End Function










Function output(path$)
	Local out:TStream=WriteFile(path)
	Local x%=0,done%=0
	Local allow$="qwertyuiopasdfghjklzxcvbnm1234567890!@#%^&*()`~~-=_+[]{};':~q,.<>/?\"
	If memstring<>"" Or othstring<> "" WriteLine out,"$~q"+memstring+" "
	If othstring<>"" WriteLine out,"$~q"+othstring+" "
	
	Local thisline%=0
	Repeat
		If mem[x]=0
			Local total%=0
			Repeat
				x:+1;total:+1
				If x=>size Then done=1
			Until mem[x]>0 Or done
			If done=0
				If total>1
					WriteByte out,32
					WriteLine out,""
					WriteLine out,"$"+x
				Else
					WriteString out,"[0]"
				EndIf
			EndIf
		EndIf
		If mem[x]<256 And done=0
			If Instr(allow,Lower(Chr(mem[x])))
				WriteByte out,mem[x]
				thisline:+1
			ElseIf Chr(mem[x])="$" Or Chr(mem[x])="|" Or Chr(mem[x])="["
				If thisline=0 Or thisline>60
					WriteString out,"["+Chr(mem[x])+"]"
					thisline:+3
				Else
					WriteString out,"$"
					thisline:+1
				EndIf
			Else
				WriteString out,"["+mem[x]+"]"
				thisline:+Len("["+mem[x]+"]")
			EndIf
		ElseIf size>256 And done=0
			WriteString out,"["+mem[x]+"]"
			thisline:+Len("["+mem[x]+"]")
		EndIf	
		If thisline=>64 WriteLine out," ";thisline=0
		x:+1
	Until x=>size Or done
	CloseFile out
End Function



Rem
Graphics 640,300
SetBlend MASKBLEND
Global font:TImage=LoadAnimImage("font/curses.png",8,12,0,256,MASKEDIMAGE)
Global cw%=640/8,ch%=300/12
Global buff@[cw,ch]
Global fg@[cw,ch]
Global bg@[cw,ch]

Global fgi%=15,bgi%=0

Global consoley%=0
Function Print(txt$)
	Color bgi
	If consoley>23 Then
		For Local xx%=0 To cw-1
		For Local yy%=1 To ch-1
			buff[xx,yy-1]=buff[xx,yy]
			fg[xx,yy-1]=fg[xx,yy]
			bg[xx,yy-1]=bg[xx,yy]
		Next
		Next
	EndIf
	Text 0,consoley
	consoley:+1
End Function

Function Clear()
	Cls
	consoley=0
End Function

Function Color(index%)
	index=index Mod 16
	Select index
		Case 0 SetColor 0,0,0
		Case 1 SetColor 128,128,128
		Case 2 SetColor 0,0,128
		Case 3 SetColor 0,0,255
		Case 4 SetColor 0,128,0
		Case 5 SetColor 0,255,0
		Case 6 SetColor 0,128,128
		Case 7 SetColor 0,255,255
		Case 8 SetColor 128,0,0
		Case 9 SetColor 255,0,0
		Case 10 SetColor 128,0,128
		Case 11 SetColor 255,0,255
		Case 12 SetColor 128,128,0
		Case 13 SetColor 255,255,0
		Case 14 SetColor 192,192,192
		Case 15 SetColor 255,255,255
	End Select
End Function
EndRem














Function SharedCommands%()

	Select Chr(mem[inmem])
		Case ">" A=mem[mem[inmem+1]]
			inmem:+2
		Case "}" B=mem[mem[inmem+1]]
			inmem:+2
		Case ")" C=mem[mem[inmem+1]]
			inmem:+2
		Case "<" mem[mem[inmem+1]]=A
			inmem:+2
		Case "{" mem[mem[inmem+1]]=B
			inmem:+2
		Case "(" mem[mem[inmem+1]]=C
			inmem:+2
			
		Case "4" A=mem[inmem+1]
			inmem:+2
		Case "5" B=mem[inmem+1]
			inmem:+2
		Case "6" C=mem[inmem+1]
			inmem:+2
		
		Case ";" Print memstring
			inmem:+1
		Case "\" memstring=Input()
			inmem:+1
		Case "~~"
			Local tmpstring$=memstring
			memstring=othstring;othstring=tmpstring
			inmem:+1
		Case "s" memstring=""
			inmem:+1
			
		Case "^" A=Asc(Mid(memstring,mem[inmem+1]-1,1))
			'Print memstring+" : "+mem[inmem+1]+" :: "+Mid(memstring,mem[inmem+1],1)
			Delay 150
			inmem:+2
		Case "`" B=Asc(Mid(memstring,mem[inmem+1]-1,1))
			inmem:+2
		Case "'" C=Asc(Mid(memstring,mem[inmem+1]-1,1))
			inmem:+2
			
		Case "U" A=Int(memstring)
			inmem:+1
		Case "V" B=Int(memstring)
			inmem:+1
		Case "W" C=Int(memstring)
			inmem:+1
			
		Case ":" memstring:+Chr(A)
			inmem:+1
		Case "." memstring:+Chr(B)
			inmem:+1
		Case "," memstring:+Chr(C)
			inmem:+1
		
		Case "1" memstring:+A
			inmem:+1
		Case "2" memstring:+B
			inmem:+1
		Case "3" memstring:+C
			inmem:+1
			
		Case "#"
			mem[mem[inmem+2]]=mem[mem[inmem+1]]
			inmem:+3
		Case "S"
			Local tmpbyte%=mem[mem[inmem+1]]
			mem[mem[inmem+1]]=mem[mem[inmem+2]]
			mem[mem[inmem+2]]=tmpbyte
			inmem:+3
		
		Case "i" mem[mem[inmem+1]]:+1
			inmem:+2
		Case "d" mem[mem[inmem+1]]:-1
			inmem:+2
			
		Case "o" A:+1
			inmem:+1
		Case "n" A:-1
			inmem:+1
		Case "u" B:+1
			inmem:+1
		Case "t" B:-1
			inmem:+1
		Case "f" C:+1
			inmem:+1
		Case "e" C:-1
			inmem:+1
		
		Case "j" inmem=mem[inmem+1]
		Case "?" If A>B Then inmem=mem[inmem+1] Else inmem:+2
		Case "!" If A<B Then inmem=mem[inmem+1] Else inmem:+2
		Case "=" If A=B Then inmem=mem[inmem+1] Else inmem:+2
		Case "N" If A<>B Then inmem=mem[inmem+1] Else inmem:+2
		
		Case "x"
			Local tmpbyte%=A
			A=B;B=tmpbyte
			inmem:+1
		Case "y"
			Local tmpbyte%=B
			B=C;C=tmpbyte
			inmem:+1
		Case "z"
			Local tmpbyte%=C
			C=A;A=tmpbyte
			inmem:+1
			
		Case "a" A=0
			inmem:+1
		Case "b" B=0
			inmem:+1
		Case "c" C=0
			inmem:+1
			
		Case "A"
			If A>0 A=0 Else A=1
			inmem:+1
		Case "B"
			If B>0 B=0 Else B=1
			inmem:+1
		Case "C"
			If C>0 C=0 Else C=1
			inmem:+1
			
		Case "Y" B=A;C=A
			inmem:+1
			
		Case "L" mem[mem[inmem+1]]=mem[mem[inmem+1]] Shl 1
			inmem:+1
		Case "R" mem[mem[inmem+1]]=mem[mem[inmem+1]] Shr 1
			inmem:+1
		
		Case "+" C=A+B
			inmem:+1
		Case "-" C=A-B
			inmem:+1
		Case "*" C=A*B
			inmem:+1
		Case "/" If B>0 C=A/B Else C=0
			inmem:+1
		Case "%" C=A Mod B
			inmem:+1
		Case "v" C=A^B
			inmem:+1
		Case "l" C=A Shl B
			inmem:+1
		Case "r" C=A Shr B
			inmem:+1
		Case "m" C=(A+B)/2
			inmem:+1
		Case "O" C=A Or B
			inmem:+1
		Case "&" C=A And B
			inmem:+1
		Case "X" C=Xor(A,B)
			inmem:+1
			
		Case "_"
			Return -1
			
		Case "@" memstring:+Chr(mem[mem[inmem+1]])
			inmem:+2
		Case "0" memstring:+mem[mem[inmem+1]]
			inmem:+2
			
		Case "7" A=Len(memstring)
			inmem:+1
		Case "8" B=Len(memstring)
			inmem:+1
		Case "9" C=Len(memstring)
			inmem:+1
			
		Case "D" Delay mem[inmem+1]
			inmem:+1
			
		Case "H" WriteStdout memstring
			inmem:+1
		Case "I" Print ""
			inmem:+1
		
		'Case "|"
		'	Print inmem+" : "+Chr(mem[inmem])+" ("+mem[inmem]+")"
		'	inmem:+1
		
		Default 
			Return 0
	End Select
	
	Return 1

End Function








Function FileCommands%(bits%)
	If bits=8
		Select Chr(mem[inmem])
			Case "F" 
				If FileType("Data\"+mem[inmem+1]+".dat")=1
					memfile=ReadFile("Data\"+mem[inmem+1]+".dat")
				Else
					memfile=WriteFile("Data\"+mem[inmem+1]+".dat")
					For Local nu%=0 To 255
						WriteByte memfile,0
					Next
				EndIf
				inmem:+2
			Case "w" 
				If memfile SeekStream memfile,mem[inmem+2]*1;WriteByte memfile,mem[mem[inmem+1]]
				inmem:+3
			Case "p" 
				If memfile SeekStream memfile,mem[inmem+2]*1;mem[mem[inmem+1]]=ReadByte(memfile)
				inmem:+3
			Case "P"
				If memfile
					SeekStream memfile,0
					Local init%=mem[inmem+1]
					For Local copy%=0 To 255
						mem[init+copy]=ReadByte(memfile)
					Next
				EndIf
				inmem:+2
			
			Default 
				Return 0
		End Select
		Return 1
	ElseIf bits=16
		Select Chr(mem[inmem])
			Case "F" 
				If FileType("Data\"+mem[inmem+1]+".dat")=1
					memfile=ReadFile("Data\"+mem[inmem+1]+".dat")
				Else
					memfile=WriteFile("Data\"+mem[inmem+1]+".dat")
					For Local nu%=0 To 255
						WriteShort memfile,0
					Next
				EndIf
				inmem:+2
			Case "w" 
				If memfile SeekStream memfile,mem[inmem+2]*1;WriteShort memfile,mem[mem[inmem+1]]
				inmem:+3
			Case "p" 
				If memfile SeekStream memfile,mem[inmem+2]*1;mem[mem[inmem+1]]=ReadShort(memfile)
				inmem:+3
			Case "P"
				If memfile
					SeekStream memfile,0
					Local init%=mem[inmem+1]
					For Local copy%=0 To 255
						mem[init+copy]=ReadShort(memfile)
					Next
				EndIf
				inmem:+2
			
			Default 
				Return 0
		End Select
		Return 1
	ElseIf bits=32
		Select Chr(mem[inmem])
			Case "F" 
				If FileType("Data\"+mem[inmem+1]+".dat")=1
					memfile=ReadFile("Data\"+mem[inmem+1]+".dat")
				Else
					memfile=WriteFile("Data\"+mem[inmem+1]+".dat")
					For Local nu%=0 To 255
						WriteInt memfile,0
					Next
				EndIf
				inmem:+2
			Case "w" 
				If memfile SeekStream memfile,mem[inmem+2]*1;WriteInt memfile,mem[mem[inmem+1]]
				inmem:+3
			Case "p" 
				If memfile SeekStream memfile,mem[inmem+2]*1;mem[mem[inmem+1]]=ReadInt(memfile)
				inmem:+3
			Case "P"
				If memfile
					SeekStream memfile,0
					Local init%=mem[inmem+1]
					For Local copy%=0 To 255
						mem[init+copy]=ReadInt(memfile)
					Next
				EndIf
				inmem:+2
			
			Default 
				Return 0
		End Select
		Return 1
	ElseIf bits=64
		Select Chr(mem[inmem])
			Case "F" 
				If FileType("Data\"+mem[inmem+1]+".dat")=1
					memfile=ReadFile("Data\"+mem[inmem+1]+".dat")
				Else
					memfile=WriteFile("Data\"+mem[inmem+1]+".dat")
					For Local nu%=0 To 255
						WriteLong memfile,0
					Next
				EndIf
				inmem:+2
			Case "w" 
				If memfile SeekStream memfile,mem[inmem+2]*1;WriteLong memfile,mem[mem[inmem+1]]
				inmem:+3
			Case "p" 
				If memfile SeekStream memfile,mem[inmem+2]*1;mem[mem[inmem+1]]=ReadLong(memfile)
				inmem:+3
			Case "P"
				If memfile
					SeekStream memfile,0
					Local init%=mem[inmem+1]
					For Local copy%=0 To 255
						mem[init+copy]=ReadLong(memfile)
					Next
				EndIf
				inmem:+2
			
			Default 
				Return 0
		End Select
		Return 1
	EndIf
End Function










Function Upto$(txt$,pos%,char$)
	Local npos%=pos,ret$
	Repeat
		Local c$=Mid(txt,npos,1)
		If c=char Return ret
		ret:+c
		If npos=>Len(txt) Print "ERROR: No closing "+char+" character detected.";Return ret
		npos:+1
	Forever
End Function

Function Xor%(x%,y%)
	If x And Not y Return 1
	If y And Not x Return 1
	Return 0
End Function







Function addlab(name$,pos%,debug%=0)
	labels:+1
	lname=lname[..labels]
	lpos=lpos[..labels]
	lname[labels-1]=Trim(Lower(name))
	lpos[labels-1]=pos
	If debug Print "Created new label "+lname[labels-1]+" at position "+lpos[labels-1]
End Function